<?php
  
  $session = $this->getSession();
  $filter_html = new Yab_Filter_Html();
  
  $sitefouille_id = $session->get('sitefouille_id') ;
  $color_contexte = array() ; 

  foreach($us_contexte as $contexte ){

    $contexte_id = $contexte->get('id') ; 
    $contexte_value = $contexte->get('categorie_value') ;
    $contexte_ident = hash('crc32', $contexte_value ) ;
        
    $color_contexte[$contexte_ident] = $contexte->toArray()  ;
    $color = !empty($color_contexte[$contexte_ident]['color']) ? $color_contexte[$contexte_ident]['color'] : '6272A3' ;
    $color_contexte[$contexte_ident]['color'] = '#'.$color ;
    
  }
    
  $network = array() ;
  foreach($network_anteroposterite as $anteroposterite ) {
    $us_id_p = $anteroposterite->get('posterieur_id') ;
    $us_nom_p = $anteroposterite->get('us_posterieur') ;
    $us_id_ident_p = hash('crc32', $us_id_p ) ;
    $title_p = '<a href="'.$this->getRequest('Dashboard_Us', 'show', array($us_id_p) ).'" target="_blank">'.$us_nom_p.'</a>' ;
    // $contexte_ident_p = hash('crc32', $anteroposterite->get('us_posterieur_contexte') ) ; 
    // $color_p = $color_contexte[$contexte_ident_p]['color'] ;
    $color_p = '#'.substr(hash('crc32', $anteroposterite->get('us_posterieur_contexte') ), -6 ) ;
    $poid_p = $anteroposterite->get('us_posterieur_link') ;
    $level_p = $anteroposterite->get('level_posterieur') ;
    
    $us_id_a = $anteroposterite->get('anterieur_id') ;
    $us_nom_a = $anteroposterite->get('us_anterieur') ;
    $us_id_ident_a = hash('crc32', $us_id_a ) ;  
    $title_a = '<a href="'.$this->getRequest('Dashboard_Us', 'show', array($us_id_a) ).'" target="_blank">D&eacute;tails</a>' ;
    // $contexte_ident_a = hash('crc32', $anteroposterite->get('us_anterieur_contexte') ) ;
    // $color_a = $color_contexte[$contexte_ident_a]['color'] ;
    $color_a = '#'.substr(hash('crc32', $anteroposterite->get('us_anterieur_contexte') ), -6 ) ;
    $poid_a = $anteroposterite->get('us_anterieur_link') ;
    $level_a = $level_p + 1 ;
    
    $network['nodes'][$us_id_p] = array(
      'id' => $us_id_ident_p,
      'name' => $us_nom_p,
      'colorContexte' => $color_p,
      'foo' =>7,
      'bar' =>9,  
      'poid' => $poid_p,
      'x' => $poid_p,        
    );
    if(!isset($network['nodes'][$us_id_p]['y']) ) {
      $network['nodes'][$us_id_p]['y'] = $level_p ;      
    }
     
    $network['nodes'][$us_id_a] = array(
      'id' => $us_id_ident_a,
      'name' => $us_nom_a,
      // 'parent' => $us_id_ident_p,
      'colorContexte' => $color_a,
      'foo' => 7,
      'bar' => 9,  
      'poid' => $poid_a, 
      'x' => $poid_a,
      'y' => $network['nodes'][$us_id_p]['y'] + 1 ,  
    );
    
    $edges = array(
      'id' => $us_id_ident_p.'_'.$us_id_ident_a,
      'weight' => 1,
      'source' => $us_id_ident_p,
      'target' => $us_id_ident_a,
      'line_color' => '#B1C1F2',
      'arrow_color' => '#B1C1F2',
      'arrow_shape' => 'triangle',
      'poid' => $poid_p * $poid_a,  
    );

    if( $anteroposterite->get('incertitude') ){
      $edges['style'] = 'dash-line' ;
      $edges['name'] = 'incertain' ; 
    } 
     
    $network['edges'][] = $edges ;
    
  } 
  
  
  foreach($network_synchronisation as $synchronisation ) {
    $us_id_l = $synchronisation->get('synchro1_id') ;
    $us_nom_l = $synchronisation->get('us_left_synchro') ;
    $us_id_ident_l = hash('crc32', $us_id_l ) ;
    $title_l = '<a href="'.$this->getRequest('Dashboard_Us', 'show', array($us_id_l) ).'" target="_blank">D&eacute;tails</a>' ;
    // $contexte_ident_l = hash('crc32', $synchronisation->get('us_left_contexte') ) ;
    // $color_l = $color_contexte[$contexte_ident_l]['color'] ;
    $color_l = '#'.substr(hash('crc32', $synchronisation->get('us_left_contexte') ), -6 ) ;
    
    $us_id_r = $synchronisation->get('synchro2_id') ;
    $us_nom_r = $synchronisation->get('us_right_synchro') ;
    $us_id_ident_r = hash('crc32', $us_id_r ) ;  
    $title_r = '<a href="'.$this->getRequest('Dashboard_Us', 'show', array($us_id_r) ).'" target="_blank">D&eacute;tails</a>' ;
    // $contexte_ident_r = hash('crc32', $synchronisation->get('us_right_contexte') ) ;
    // $color_r = $color_contexte[$contexte_ident_r]['color'] ;
    $color_r = '#'.substr(hash('crc32', $synchronisation->get('us_right_contexte') ), -6 ) ; 
    
    $network['nodes'][$us_id_l] = array(
      'id' => $us_id_ident_l,
      'name' => $us_nom_l,
      'colorContexte' => $color_l,
      'foo' =>7,
      'bar' =>9,
    ); 
    if(!isset($network['nodes'][$us_id_l]['poid']) ) {
      $network['nodes'][$us_id_l]['poid'] = 1 ;
      $network['nodes'][$us_id_l]['x'] = 1 ;       
    }
    if(!isset($network['nodes'][$us_id_l]['y']) ) {
      if(!isset($network['nodes'][$us_id_r]['y']) ) {
        // Aucun des deux n'est défini
        $network['nodes'][$us_id_l]['y'] = 1 ;
        $network['nodes'][$us_id_r]['y'] = 1 ;       
      } else {
        // report de la valeur du second sur le premier 
        $network['nodes'][$us_id_l]['y'] =  $network['nodes'][$us_id_r]['y'] ;      
      } 
    } else {
      if(!isset($network['nodes'][$us_id_r]['y']) ) {
        // le second n'est pas défini
        // report de la valeur du premier sur le second
        $network['nodes'][$us_id_r]['y'] =  $network['nodes'][$us_id_l]['y'] ;      
      } else {
        // les deux sont défini
        // max des deux
        if ($network['nodes'][$us_id_r]['y'] <= $network['nodes'][$us_id_l]['y'] ) {
          $network['nodes'][$us_id_r]['y'] = $network['nodes'][$us_id_l]['y'] ;        
        } else {
          $network['nodes'][$us_id_l]['y'] = $network['nodes'][$us_id_r]['y'] ;        
        }
              
      }
    
    } 
    
    $network['nodes'][$us_id_r] = array(
      'id' => $us_id_ident_r,
      'name' => $us_nom_r,
      'colorContexte' => $color_r,
      'foo' =>7,
      'bar' =>9,  
      'poid' => $network['nodes'][$us_id_l]['poid'] + 1,
      'x' => $network['nodes'][$us_id_l]['x'] + 1,
    );

    $edges = array(
      'id' => $us_id_ident_l.'_'.$us_id_ident_r,
      'weight' => 1,
      'source' => $us_id_ident_l,
      'target' => $us_id_ident_r,
      'line_color' => '#1570A6',
      'arrow_color' => '#1570A6',
      'arrow_shape' => 'none',
      'poid' => $network['nodes'][$us_id_l]['poid'] * $network['nodes'][$us_id_r]['poid']
    );
    if( $synchronisation->get('incertitude') ){
      $edges['style'] = 'dash-line' ;
      $edges['label'] = 'incertain' ; 
    } 
     
    $network['edges'][] = $edges ;        
  } 
  $network_edges = $network['edges'] ;
  
  $network['nodes'] = array_orderby($network['nodes'],'poid', SORT_DESC) ;
  
  foreach($network['nodes'] as $node ) {
    $network_nodes[]['data'] = $node ;
  } 
    
  $network['edges'] = array_orderby($network['edges'],'poid', SORT_DESC ) ;  
  foreach($network['edges'] as $node ) {
    $network_edges[]['data'] = $node ;
  } 

  
  $network_nodes = json_encode($network_nodes,  JSON_UNESCAPED_SLASHES | JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE ) ;
  $network_edges = json_encode($network_edges, JSON_UNESCAPED_SLASHES | JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE ) ;



  // identifiant unique de la div d'affichage 
  $unique_div = rand();
  
  function array_orderby()
  {
      $args = func_get_args();
      $data = array_shift($args);
      foreach ($args as $n => $field) {
          if (is_string($field)) {
              $tmp = array();
              foreach ($data as $key => $row)
                  $tmp[$key] = $row[$field];
              $args[$n] = $tmp;
              }
      }
      $args[] = &$data;
      call_user_func_array('array_multisort', $args);
      return array_pop($args);
  }
  
?>
<?php 
  // test si page autonome ( dans un layout ) ou incluse dans une autre.
  // permet de ne pas redefinir l'appel highcharts de multiple fois
  if (!$this->getLayout()->getEnabled() ) { 
?>


<?php  } ?>
<style>

#sdf_us_network_us<?php echo $unique_div  ; ?> {
  /* height: 50%; */
  width: 100%;
  position: absolute;
  left: 0;
  top: 0;
  background-color: #FAEDEF;
}

</style>

<script src="<?php echo $request->getBaseUrl(); ?>/js/cytoscape.js"></script>

<script type="text/javascript">

  $(function(){ // on dom ready
  
    var elesJson = {
      nodes: <?php echo $network_nodes ; ?>,
      edges: <?php echo $network_edges ; ?>
    } ;
     
  var cy = cytoscape({
    container: document.getElementById('network_us_<?php echo $unique_div  ; ?>'),
    style: cytoscape.stylesheet()
      .selector('node')
        .css({
          'shape': 'rectangle',
          'width': 'mapData(foo, 0, 10, 10, 50)',
          'height': 'mapData(bar, 0, 10, 10, 30)',
          'content': 'data(name)',
          'background-color': 'data(colorContexte)',
        })
      .selector('edge')
        .css({
          'width': 'mapData(weight, 0, 10, 3, 9)',
          'line-color': 'data(line_color)',
          'target-arrow-color': 'data(arrow_color)',
          'target-arrow-shape': 'data(arrow_shape)',
          'opacity': 0.8
        })
      .selector(':selected')
        .css({
          'background-color': 'black',
          'line-color': 'black',
          'target-arrow-color': 'black',
          'source-arrow-color': 'black',
          'opacity': 1
        }),
    
    elements: elesJson,
    
    layout: {
      name: 'breadthfirst',
      // directed: true,
      // padding: 10
      fit: true, // whether to fit the viewport to the graph
      directed: true, // whether the tree is directed downwards (or edges can point in any direction if false)
      padding: 30, // padding on fit
      circle: false, // put depths in concentric circles if true, put depths top down if false
      boundingBox: undefined, // constrain layout bounds; { x1, y1, x2, y2 } or { x1, y1, w, h }
      avoidOverlap: true, // prevents node overlap, may overflow boundingBox if not enough space
      roots: undefined, // the roots of the trees
      maximalAdjustments: 0, // how many times to try to position the nodes in a maximal way (i.e. no backtracking)
      animate: false, // whether to transition the node positions
      animationDuration: 500, // duration of animation in ms if enabled
      // ready: undefined, // callback on layoutready
      // stop: undefined // callback on layoutstop
    },
    ready: function(){
      // ready 2
      
      // console.log('ready');
      // console.log( cy.json() );
            
    }
  });

  var options = {
    name: 'breadthfirst',
  
    fit: true, // whether to fit the viewport to the graph
    directed: true, // whether the tree is directed downwards (or edges can point in any direction if false)
    padding: 30, // padding on fit
    circle: false, // put depths in concentric circles if true, put depths top down if false
    boundingBox: undefined, // constrain layout bounds; { x1, y1, x2, y2 } or { x1, y1, w, h }
    avoidOverlap: true, // prevents node overlap, may overflow boundingBox if not enough space
    roots: undefined, // the roots of the trees
    maximalAdjustments: 0, // how many times to try to position the nodes in a maximal way (i.e. no backtracking)
    animate: false, // whether to transition the node positions
    animationDuration: 500, // duration of animation in ms if enabled
    // ready: undefined, // callback on layoutready
    // stop: undefined // callback on layoutstop
  };
 
//   cy.layout( options );
  cy.resize() ;
  
}); // on dom ready
    
</script>

<div id="network_us_<?php echo $unique_div  ; ?>"  style="height: 600px"></div>
